class Born < ThingTank::Character
  property :birth_date, :alias => :born_at
  property :birth_place

  validates_presence_of :birth_date # make sure a date is given
end

# just in case he might die....we might want to have a date and maybe even a place
class Dead < ThingTank::Character
  property :date_of_death
  property :place_of_death

  validates_presence_of :date_of_death
end

class Person < ThingTank::Character
  property :name
  property :gender

  validates_presence_of :name
end

def test_bear_julius
  julius = create({ :gender => :m, :name => 'Gaius Iulius Caesar' })
  assert julius.could_be? Person

  julius["birth_date"] = "100 BC"
  julius["birth_place"] = "Rome"

  assert julius.could_be? Born

  julius.is(Born)
  julius.is(Person)
  julius.save
  julius.reload

  assert julius.is? Person
  assert julius.is? Born

  assert_equal 'Gaius Iulius Caesar', julius["name"]
  assert_equal 'Rome', julius["birth_place"]

  assert !julius["characters"].nil?
  assert_equal 2, julius["characters"].size
  assert julius["characters"].include? Person.to_s
  assert julius["characters"].include? Born.to_s
  assert_equal "100 BC", julius.is(Born).born_at

  return julius
end
