require 'rubygems'
require 'bundler'
begin
  Bundler.setup(:default, :development)
rescue Bundler::BundlerError => e
  $stderr.puts e.message
  $stderr.puts "Run `bundle install` to install missing gems"
  exit e.status_code
end

if RUBY_VERSION =~ /1.8/ 
  require 'backports'
end 

$LOAD_PATH.unshift(File.dirname(__FILE__))
$LOAD_PATH.unshift(File.join(File.dirname(__FILE__), '..', 'lib'))
#$LOAD_PATH.unshift(File.join(File.dirname(__FILE__), '..', 'lib', 'thingtank'))
$LOAD_PATH.unshift(File.join(File.dirname(__FILE__), '..', 'examples'))
require 'thingtank.rb'
require 'minitest/autorun'
unless defined?(COUCHHOST)
  COUCHHOST = CouchRest.database ENV['COUCH_POTATO_TEST_DB']
end

#require 'ruby-debug'

class ThingTank
  use_database COUCHHOST
end

def reset_test_db!
  ThingTank.database.recreate! rescue nil 
  ThingTank.database
end

def create(hsh={})
  doc = ThingTank.create hsh
  doc.save
  doc.reload
  doc
end

def new(hsh={})
  ThingTank.new hsh
end

def db_load(id)
  #"ThingTank".constantize.new(ThingTank.database.get(id), :directly_set_attributes => true) # same as ThingTank.get id
  ThingTank.get id
end

class Check < ThingTank::Character
  property :a
  property :c
  property :check_saved
  property :check_updated
  property :check_created
  property :check_destroyed
  property :shared 

  def ping
    "pong"
  end

  def access_other_character
    checker = database.to_character(Checker)
    checker["checker1"] = "I was here"
  end

  def set_properties_we_don_t_have
    self["ooops"] = "got it"
  end

  def set_properties_of_doc
    _doc["ooops"] = "got it"
  end

  before_save do
    self["check_saved"] = true
  end

  before_update do
    self["check_updated"] = true
  end

  before_create do
    self["check_created"] = true
  end

  before_destroy do
    self["check_destroyed"] = true
    #p :check_destroyed
    true
  end

  validates_presence_of :a
end

class Checker < ThingTank::Character
  property :shared
  property :checker1

end

class Testmodel < CouchRest::Model::Base
end

